﻿using System.IO;
using System.Threading.Tasks;
using System.Windows;
using Infragistics.Documents.Excel;
using Microsoft.Win32;
using Path = System.IO.Path;

namespace SpreadsheetMinimalPrototype
{
	/// <summary>
	/// Interaction logic for MainWindow.xaml
	/// </summary>
	public partial class MainWindow : Window
	{
		public MainWindow()
		{
			InitializeComponent();
			Loaded += OnLoaded;
		}

		private void OnLoaded(object sender, RoutedEventArgs e)
		{
			var filePath = Path.Combine(Directory.GetCurrentDirectory(),"Hanging_tests.xlsx");
			SpreadSheet.Workbook = CreateFromFileExcel(filePath);
			Task.Run(ShowInstructions);
		}

		private void ShowInstructions() =>
			MessageBox.Show("In the 'Links' sheet Activate A2 or B2 cell" +
				"\r\nClick drop down list - App is hanging" +
				"\r\nTry to do same in opened Excel application - no hanging problem",
				"Instructions", MessageBoxButton.OK, MessageBoxImage.Information);

		private void ButtonLoadCustom_Click(object sender, RoutedEventArgs e)
		{
			var openFileDialog = new OpenFileDialog();
			openFileDialog.Filter = "Excel | *.xlsx";
			var result = openFileDialog.ShowDialog();
			if (result.HasValue && result.Value)
			{
				SpreadSheet.Workbook = CreateFromFileExcel(openFileDialog.FileName);
			}
		}

		private Workbook CreateFromFileExcel(string fileName)
		{
			using (var fs = File.OpenRead(fileName))
			{
				return Workbook.Load(fs);
			}
		}
    }
}
